<template>
  <div class="column root" @mouseenter="handleMouseEnter" @mouseleave="handleMouseLeave">
    <q-card class="col-grow bg-blue-grey-1">
      <q-card-section class="row justify-evenly" style="height: 80px">
        <q-btn
          v-if="!hasTemplate"
          push
          color="white"
          text-color="teal"
          icon="mdi-view-grid-plus"
          label="New task"
          @click="handlePickTask"
        />
        <div v-else class="row justify-evenly">
          <q-btn
            class="col"
            push
            icon="mdi-view-grid"
            label="Edit"
            color="white"
            text-color="teal"
            @click="handlePickTask"
            :disable="$props.options.isRunning"
          />
<!--           <q-btn
            class="col-3"
            flat
            icon="delete"
            color="white"
            text-color="negative"
            @click="handleClearTemplate"
            :disable="$props.options.isRunning"
          /> -->
        </div>
      </q-card-section>

      <q-card-section class="row justify-center items-center">
        <q-btn
          class="col-9"
          flat
          icon="edit"
          color="primary"
          :disable="$props.options.isRunning"
          @click="showDialog = true"
          label="Parameters"
        />
      </q-card-section>
      <q-card-section class="column justify-center items-center">
        <span class="text-weight-light text-italic">{{ iterationsCount }}</span>
      </q-card-section>
      <div class="side-menu" v-show="isSelected">
        <q-btn
          round
          push
          icon="clear"
          size="md"
          color="white"
          text-color="negative"
          @click="handleDelete"
          :disable="$props.options.isRunning"
        ></q-btn>
      </div>
<!--       <div class="selected-bar column items-center justify-center">
        <q-linear-progress class="col" color="cyan" :value="$props.block.currentTime" />
        <span class="col">{{ $props.block.currentIteration }} / {{ $props.block.queue.length }}</span>
      </div> -->
    </q-card>
  </div>
  <loop-dialog v-model:show="showDialog" v-model:loopMap="loopMap" v-model:loopMode="loopMode" />
</template>

<script lang="ts">
import { defineComponent, PropType, ref, computed } from 'vue';
import { ExperimentBlock, ExperimentOptions } from 'src/models/experiment';
import LoopDialog from './LoopDialog.vue';
import { refinedToLoopmap } from 'src/components/conversions';

export default defineComponent({
  components: { LoopDialog },
  emits: ['selected', 'delete', 'pick', 'clear', 'updated:map', 'update:loopMap'],
  props: {
    block: {
      type: Object as PropType<ExperimentBlock>,
      default: () => {
        return {
          id: '',
          currentTime: 0,
          currentIteration: 0,
          queue: [],
          rawTemplate: null,
          template: {
            testbed: {
              parameters: {},
              loggable: [],
            },
            controllers: {},
            references: {},
          },
          loopMap: refinedToLoopmap({
            testbed: {
              parameters: {},
              loggable: [],
            },
            controllers: {},
            references: {},
          }),
        } as ExperimentBlock;
      },
    },
    options: {
      type: Object as PropType<ExperimentOptions>,
      default: () => {
        return {
          selected: '',
          isRunning: false,
        } as ExperimentOptions;
      },
    },
  },

  setup(props, { emit }) {
    const showDialog = ref(false);

    const isSelected = computed(() => props.options.selected === props.block.id);
    const hasTemplate = computed(() => props.block.template !== null);

    const handleClearTemplate = () => {
      emit('clear');
    };

    const handleMouseEnter = () => {
      if (props.options.selected !== props.block.id) emit('selected', props.block.id);
    };

    const handleMouseLeave = () => {
      emit('selected', '');
    };

    const handleDelete = () => {
      emit('delete');
    };

    const iterationsCount = computed(() => {
      const count = props.block.queue.length;
      return count > 0 ? count.toString() + ' total iteration' + (count !== 1 ? 's' : '') : 'No task selected';
    });

    const handlePickTask = () => {
      emit('pick');
    };

    const loopMode = ref('cartesian');

    const loopMap = computed({
      get: () => props.block.loopMap,
      set: (value) => {
        emit('update:loopMap', [value, loopMode.value]);
      },
    });

    return {
      isSelected,
      hasTemplate,
      iterationsCount,
      handleClearTemplate,
      handleMouseEnter,
      handleMouseLeave,
      handlePickTask,
      handleDelete,
      showDialog,
      loopMap,
      loopMode
    };
  },
});
</script>

<style lang="sass" scoped>
.root
  width: 250px
  height: 250px
  margin-left: 24px
  margin-right: 24px
  cursor: pointer
  transition: all .25s ease-in-out
  &:hover
    transform: scale(1.05)

.side-menu
  position: absolute
  top: -24px
  right: -24px
  z-index: 3

.selected-bar
  position: absolute
  bottom: -24px
  width: 100%
  height: 5px
</style>
